BackupStorageLocation [velero.io/v1]

Description
BackupStorageLocation is a location where Velero stores backup objects
Type
object

Specification

PropertyTypeDescription
apiVersionstring

APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources

kindstring

Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds

metadataObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

specobject

BackupStorageLocationSpec defines the desired state of a Velero BackupStorageLocation

statusobject

BackupStorageLocationStatus defines the observed state of BackupStorageLocation

.spec

Description
BackupStorageLocationSpec defines the desired state of a Velero BackupStorageLocation
Type
object
Required
objectStorageprovider
PropertyTypeDescription
accessModestring

AccessMode defines the permissions for the backup storage location.

backupSyncPeriodstring

BackupSyncPeriod defines how frequently to sync backup API objects from object storage. A value of 0 disables sync.

configobject

Config is for provider-specific configuration fields.

credentialobject

Credential contains the credential information intended to be used with this location

defaultboolean

Default indicates this location is the default backup storage location.

objectStorageobject

ObjectStorageLocation specifies the settings necessary to connect to a provider's object storage.

providerstring

Provider is the provider of the backup storage.

validationFrequencystring

ValidationFrequency defines how frequently to validate the corresponding object storage. A value of 0 disables validation.

.spec.config

Description
Config is for provider-specific configuration fields.
Type
object

.spec.credential

Description
Credential contains the credential information intended to be used with this location
Type
object
Required
key
PropertyTypeDescription
keystring

The key of the secret to select from. Must be a valid secret key.

namestring

Name of the referent. More info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names TODO: Add other useful fields. apiVersion, kind, uid?

optionalboolean

Specify whether the Secret or its key must be defined

.spec.objectStorage

Description
ObjectStorageLocation specifies the settings necessary to connect to a provider's object storage.
Type
object
Required
bucket
PropertyTypeDescription
bucketstring

Bucket is the bucket to use for object storage.

caCertstring

CACert defines a CA bundle to use when verifying TLS connections to the provider.

prefixstring

Prefix is the path inside a bucket to use for Velero storage. Optional.

.status

Description
BackupStorageLocationStatus defines the observed state of BackupStorageLocation
Type
object
PropertyTypeDescription
accessModestring

AccessMode is an unused field.

Deprecated: there is now an AccessMode field on the Spec and this field will be removed entirely as of v2.0.

lastSyncedRevisionstring

LastSyncedRevision is the value of the metadata/revision file in the backup storage location the last time the BSL's contents were synced into the cluster.

Deprecated: this field is no longer updated or used for detecting changes to the location's contents and will be removed entirely in v2.0.

lastSyncedTimestring

LastSyncedTime is the last time the contents of the location were synced into the cluster.

lastValidationTimestring

LastValidationTime is the last time the backup store location was validated the cluster.

messagestring

Message is a message about the backup storage location's status.

phasestring

Phase is the current state of the BackupStorageLocation.

API Endpoints

The following API endpoints are available:

  • /apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations
    • DELETE: delete collection of BackupStorageLocation
    • GET: list objects of kind BackupStorageLocation
    • POST: create a new BackupStorageLocation
  • /apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations/{name}
    • DELETE: delete the specified BackupStorageLocation
    • GET: read the specified BackupStorageLocation
    • PATCH: partially update the specified BackupStorageLocation
    • PUT: replace the specified BackupStorageLocation
  • /apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations/{name}/status
    • GET: read status of the specified BackupStorageLocation
    • PATCH: partially update status of the specified BackupStorageLocation
    • PUT: replace status of the specified BackupStorageLocation

/apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations

HTTP method
DELETE
Description
delete collection of BackupStorageLocation
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind BackupStorageLocation
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocationList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyBackupStorageLocation schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
201 - CreatedBackupStorageLocation schema
202 - AcceptedBackupStorageLocation schema
401 - UnauthorizedEmpty

/apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations/{name}

HTTP method
DELETE
Description
delete the specified BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified BackupStorageLocation
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyBackupStorageLocation schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
201 - CreatedBackupStorageLocation schema
401 - UnauthorizedEmpty

/apis/velero.io/v1/namespaces/{namespace}/backupstoragelocations/{name}/status

HTTP method
GET
Description
read status of the specified BackupStorageLocation
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified BackupStorageLocation
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyBackupStorageLocation schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKBackupStorageLocation schema
201 - CreatedBackupStorageLocation schema
401 - UnauthorizedEmpty